MODULE Main ;

IMPORT IO, SearchTree, Traversal ;


VAR i : INTEGER ;
BEGIN
    SearchTree.Init() ;
    
    WHILE NOT IO.EOF() DO
        TRY
            i := IO.GetInt() ;
        EXCEPT
          IO.Error => EXIT ;
        END ;
        SearchTree.Insert(i) ;
    END ;

    IO.Put("Rekursive InOrder-Traversierung:\n") ;
    SearchTree.Write() ;

    IO.Put("\n\nlineares Durchsuchen:\n") ;
    FOR i := -1000 TO 1000 DO
        IF SearchTree.Search(i) THEN
            IO.PutInt(i) ;
            IO.Put("\n") ;
        END ;
    END ;
    
    IO.Put("\n\nPreOrder-Traversierung:\n") ;
    Traversal.TraversePreOrder() ;
    IO.Put("\n\nInOrder-Traversierung:\n") ;
    Traversal.TraverseInOrder() ;
    IO.Put("\n\nPostOrder-Traversierung:\n") ;
    Traversal.TraversePostOrder() ;
    IO.Put("\n\nLevelOrder-Traversierung:\n") ;
    Traversal.TraverseLevelOrder() ;
END Main .
