MODULE SearchTree ;

IMPORT IO ;


PROCEDURE Init() =
BEGIN
    root := NIL ;
END Init ;


PROCEDURE Insert(key : Item) =
VAR p, n : Node ;
BEGIN
    n := NEW(Node) ;
    n^.key   := key ;
    n^.left  := NIL ;
    n^.right := NIL ;

    IF root = NIL THEN
        root := n ;
    ELSE
        p := root ;
        LOOP
            IF key <= p^.key THEN
                IF p^.left = NIL THEN
                    p^.left := n ;
                    RETURN ;
                ELSE
                    p := p^.left ;
                END ;
            ELSE (* key > p^.key *)
                IF p^.right = NIL THEN
                    p^.right := n ;
                    RETURN ;
                ELSE
                    p := p^.right ;
                END ;
            END ;
        END ;  
    END ;
END Insert ;


PROCEDURE Search(key : Item) : BOOLEAN =
VAR n : Node ;
BEGIN
    n := root ;
    WHILE n # NIL DO
        IF key = n^.key THEN
            RETURN TRUE ;
        ELSIF key <= n^.key THEN
            n := n^.left ;
        ELSE (* key > n^.key *)
            n := n^.right ;
        END ;
    END ;
    RETURN FALSE ;
END Search ;


PROCEDURE WriteSubTree(n : Node) =
BEGIN
    IF n # NIL THEN 
        WriteSubTree(n^.left) ;

        IO.PutInt(n^.key) ;
        IO.Put("\n") ;

        WriteSubTree(n^.right) ;
    END;
END WriteSubTree ;


PROCEDURE Write() =
BEGIN
    WriteSubTree(root) ;
END Write ;



BEGIN
END SearchTree .
